function [ttime timeNoiseLevels finalImg] = Denoising(img, noiseMap, maxNoise)

tic

numLayers = ceil(maxNoise/10);
%%% -------------------------------

%%% Computing the representative noise levels
sigma = ComputeRepresentativeLevels(noiseMap, numLayers);

ttime = toc;
%%% -------------------------------

%%% Denoising Layers --------------
tic

fprintf('Denoising levels ...');

% This is the function that denoise the input noisy image
% according to different sigma levels. The BM3D denosing
% method in this function can be replaced with any other
% denoising algorithm.
denoisedLevels = DenoisingLevels(img, sigma);

fprintf(repmat('\b', 1, 3));
fprintf('Done\n');

timeNoiseLevels = toc;
ttime = ttime + timeNoiseLevels;
%%% -------------------------------


%%% Combining layers---------------
tic
fprintf('Combining layers ...');
denoisedImg = CombiningLayers(denoisedLevels, noiseMap, sigma);
fprintf(repmat('\b', 1, 3));
fprintf('Done\n');
%%% -------------------------------

%%% Removing Spikes ---------------
finalImg = SpikeRemoval(denoisedImg);
ttime = ttime + toc;
%%% -------------------------------