//Note that part of this Image class is borrowed from Dr.Pradeep Sen's skeleton code in the Intro. Computer Graphics class


#ifndef IMAGE_H
#define IMAGE_H

/* I use the windows class CImage to read/write images.  If you have questions,
   read more about it on MSDN. */
#include <atlimage.h>
#include "globals.h"

class Image {
	

	public:

		u08 *data;				/* unsigned char data array for image */
		int width, height;		/* stores the image dimensions */

		/* constructor */
		Image(char *name);

		Image(int imgwidth, int height);

		
		/* destructor */
		~Image() {
			if (data) {
				free(data);	
			}
		};

		/* check to make sure image is of the right format */
		void basicImageChecks(CImage *image);

		/* copy the data between the CImage data structure and the data array */
		void copyImageData(CImage *image);		/* read from CImage to the data array */
		void copyBackImageData(CImage *image);	/* read from the data array to CImage */

		/* functions to save the image out to a file */
		void saveImage(char *name);
		void saveToBMP(char *name);		// use this one when the image is very, very large (photomosaic)

		void copyImage(Image* oriImg, Image* newImg);
};

#endif		/* IMAGE_H */